

proc Set_V775_Options {} {
    global Options V775_Base

    load_Options

   if {![info exists Options(v775.channels)]} {set Options(v775.channels) 4096}
   if {![info exists Options(v775.offset)]} {set Options(v775.offset) 0}
   if {![info exists Options(v775.shift)]} {set Options(v775.shift) 0}
   if {![info exists Options(v775_GroupBase)]} {set Options(v775_GroupBase) $V775_Base}
   set V775_Base   $Options(v775_GroupBase)

    update_Options
}

proc Dump_Raw_VME_Data_V775 {data} {

   set info ""

      set data "$data\n"

   return $info
}

proc define_V775_config {} {
   global VMEserver
    global V775_Base

   set maxmodule [inform vmecontrol inquire v775count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   if {$maxmodule > 0} then {DefineConfig "775 0 [format "0x%x" $V775_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v775#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v775#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "775 $i [string range [first $m] 2 end]"
   }
}

proc create_V775_spectra {} {
    global SpectrumServer V775_Base
    global Options

   set maxmodule [inform vmecontrol inquire v775count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   set maxadc 32

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module v775#$i"

    for {set j 0} {$j < $maxadc} {incr j} {

      set spectrumname [SpectrumName v775#$i.adc$j]
      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(v775.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  v775#$i.adc$j"
          clear-footer
          error $m
      } else {
          set group [expr $V775_Base - 1 + $i]
          map_spectrum  "$spectrumname $group $j $Options(v775.offset) $Options(v775.shift)"
      }
    }
   }
}
