#    most of this task is now taken from the standard application

set VERSION "VHSADC"

#    put some default environment variables before loading common 

set env(RDOUThdwre) cPCI
set env(RDOUTserver) daq


loadsource  sys.common


set SpectrumServerList {Memsas}
set SpectrumServer [first $SpectrumServerList]

set Supported_Modules {}

set DADirectory $Win32Directory
set DAProgram VHSADCexecV1

lappend setuplist [list "Show histogram name translations" "Show_Xlate"]
lappend setuplist [list "Edit histogram translation file"  "edit_xlate"]

set frametitle "MIDAS Data Acquisition Experiment Control (VHSADC)"

set TSPresent 1
set TSEnable 0
set txEnable 0

set histEnable 1
set HistMode 1

set TestBuffer ""

set Options(Include.VHSADC) 1

proc create_spectra {} {
   global SpectrumServer HistMode EGreport

   if {$HistMode == 0} {return}
   
   set-footer "Creating spectra"
   set-busy

   set EGreport_SAVE $EGreport
   set EGreport -1

   Make_Xlate $SpectrumServer

   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 512 :name 'Stat' !new)" } m]
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 512 :name 'Rate' !new)" } m]

   map_spectrum "Stat 0 0 0 0 0"      ;#  map as group 0 item 0

#   for the VHSADC 16 channel module

   set maxmodule [inform vhsadc inquire maxboards]
   set maxadc 16

   for {set i 1} {$i <= $maxmodule} {incr i} {

#    histogram used to display the digital trace
#    need to obtain trace length from the board

      set vl [inform vhsadc get_framesize [expr $i-1]]

      if {$vl <= 0} {
          midas-warning "VHS-ADC module $i not correctly setup; frame size = $vl\nNo histograms will be created."
          continue
      }

      for {set j 1} {$j <= $maxadc} {incr j} {

         set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $vl :name 'vhsadc#$i.ch$j' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            display-eg-error-report self $m "Attempting to create spectrum vhsadc#$i.ch$j"
            clear-footer
            error $m
         } else {
            map_spectrum  "vhsadc#$i.ch$j [expr 256 + ($i * $maxadc) + ($j - 1)] 0 0 0"
         }
      }
   }

   set EGreport $EGreport_SAVE

   clear-busy
   clear-footer
}

proc Custom_PreSetup {args} {
    ClearConfig
    do_pgmoption POLLTICKS 50000
}

proc Stop_Electronics {} {
    inform vhsadc do_acqGO 0
}

proc Go_Electronics {} {
    inform vhsadc do_acqGO 1
}

proc Reset_Electronics {} {
       global RegisterServer
}

proc click-histenable {v} {
    global RDOUThdwre RDOUTEnable histEnable
    if {$RDOUTEnable == 0} then {set  histEnable 0} else {set histEnable $v}
    if {$RDOUTEnable != 0} then {write-register NetVar.DACQ.Chistenable [expr $histEnable * 10]}
    redisplay-histenable
}
